> ## Documentation Index
> Fetch the complete documentation index at: https://www.c1.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Set

> Set replaces all user owners for a given app and role.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples put /api/v2/apps/{app_id}/owners
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v2/apps/{app_id}/owners:
    put:
      tags:
        - App Owner V2
      summary: Set
      description: Set replaces all user owners for a given app and role.
      operationId: c1.api.app.v2.AppOwners.Set
      parameters:
        - in: path
          name: app_id
          required: true
          schema:
            description: The appId field.
            readOnly: false
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/c1.api.app.v2.SetAppOwnersRequestInput'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/c1.api.app.v2.SetAppOwnersResponse'
          description: SetAppOwnersResponse is the empty response for setting app owners.
      x-codeSamples:
        - lang: go
          label: Set
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/shared\"\n\tconductoronesdkgo \"github.com/conductorone/conductorone-sdk-go\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := conductoronesdkgo.New(\n        conductoronesdkgo.WithSecurity(shared.Security{\n            BearerAuth: \"<YOUR_BEARER_TOKEN_HERE>\",\n            Oauth: \"<YOUR_OAUTH_HERE>\",\n        }),\n    )\n\n    res, err := s.AppOwnersV2.Set(ctx, operations.C1APIAppV2AppOwnersSetRequest{\n        AppID: \"<id>\",\n    })\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.SetAppOwnersResponseV2 != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: >-
            import { ConductoroneSDKTypescript } from
            "conductorone-sdk-typescript";


            const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
              security: {
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
                oauth: "<YOUR_OAUTH_HERE>",
              },
            });


            async function run() {
              const result = await conductoroneSDKTypescript.appOwnersV2.set({
                appId: "<id>",
              });

              console.log(result);
            }


            run();
components:
  schemas:
    c1.api.app.v2.SetAppOwnersRequestInput:
      description: >-
        SetAppOwnersRequest is the request for setting user owners for an app
        and role.
      properties:
        appEntitlementRefs:
          description: The appEntitlementRefs field.
          items:
            $ref: '#/components/schemas/c1.api.app.v1.AppEntitlementRef'
          nullable: true
          readOnly: false
          type: array
        roleSlug:
          description: The roleSlug field.
          readOnly: false
          type: string
        userRefs:
          description: The userRefs field.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserRef'
          nullable: true
          readOnly: false
          type: array
      title: Set App Owners Request
      type: object
      x-speakeasy-name-override: SetAppOwnersRequestV2
    c1.api.app.v2.SetAppOwnersResponse:
      description: SetAppOwnersResponse is the empty response for setting app owners.
      title: Set App Owners Response
      type: object
      x-speakeasy-name-override: SetAppOwnersResponseV2
    c1.api.app.v1.AppEntitlementRef:
      description: The AppEntitlementRef message.
      properties:
        appId:
          description: The appId field.
          readOnly: false
          type: string
        id:
          description: The id field.
          readOnly: false
          type: string
      title: App Entitlement Ref
      type: object
      x-speakeasy-name-override: AppEntitlementRef
    c1.api.user.v1.UserRef:
      description: A reference to a user.
      properties:
        id:
          description: The id of the user.
          readOnly: false
          type: string
      title: User Ref
      type: object
      x-speakeasy-name-override: UserRef
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````